'''
Name: 

Overview: 

Description:
    
Notes:

Author: 

Modifications:

'''


logChn = None

import os
import sys
import pdb

import arcpy

from srd.srd_exception import *
import srd.srd_logging as srd_logging
import srd.srd_misc as srd_misc

from avi_transfer_att_by_area import *

## Set to 1 if you wish to use the DEBUG mode arguments.
DEBUG = 0
#====================================================================
if __name__ == '__main__':

    if DEBUG:
        # Modify arguments to simulate those passed from toolbox.
        # You will have to modify these based on your scripts requirements.
        sys.argv = [sys.argv[0],
                    r'D:\testData\AVI\transfer_atts\src_features.gdb\BF_GEO_FMA_POLYGON',
                    r'D:\testData\AVI\transfer_atts\avie.gdb\avie',
                    'FMA_NAME',
                    '']        
        print('\n***\n*** IN DEBUG MODE\n***')
        arcpy.AddMessage('\n***\n*** IN DEBUG MODE\n***')

    # Modify as required.
    arcpy.env.overwriteOutput = True
    # If using geographic features then may be best to modify these.
    arcpy.env.XYTolerance = .001
    arcpy.env.XYResolution = .0001
    arcpy.gp.logHistory = False
    
    try:

        logFilePath = srd_misc.getLogFilePath(sys.argv[0])
        logChn = srd_logging.SRD_Log(logFilePath)

        #-------------------------------------------------------------
        # Set the log file.
        if logFilePath:
            try:
                # Parameters to tool will be written to log file in case of problems.
                params = arcpy.GetParameterInfo()
                hdrList = ['Arguments:']
                for param in params:
                    hdrList.append('Name: %s, Type: %s, Value: %s' % (param.name, param.parameterType, param.value))
                logChn.stampHeader(hdrList)
                arcpy.AddMessage('\n*** Log information will be written to: %s\n' % logFilePath)
                logChn.stampHeader(hdrList)
                arcpy.AddMessage('\n*** Log information will be written to: %s\n' % logFilePath)
            except:
                pass
        ##==============================
        ## Modify parameters as needed.
        srcFCPathArg = arcpy.GetParameterAsText(0)
        outFCPathArg = arcpy.GetParameterAsText(1)
        fromFieldArg = arcpy.GetParameterAsText(2)
        toFieldArg = arcpy.GetParameterAsText(3)
        if not toFieldArg:
            toFieldArg = fromFieldArg
    
        myObj = Transfer_By_Area()

        myObj.transferAttributeByArea(srcFCPathArg, outFCPathArg, fromFieldArg, toFieldArg)

        ##============================================================
        
    except SRD_Exception as e:
        if logChn:
            logChn.logError(e)
            logChn.logError(srd_misc.exceptionDetails(sys.exc_info()[2]))
        else:
            arcpy.AddMessage(srd_misc.exceptionDetails(sys.exc_info()[2]))
    except Exception as e:
        if logChn:
            logChn.logError(e)
            logChn.logError(srd_misc.exceptionDetails(sys.exc_info()[2]))
        else:
            arcpy.AddMessage(srd_misc.exceptionDetails(sys.exc_info()[2]))
    else:
        logChn.logMsg('\n*** %s completed normally\n' % sys.argv[0])
    finally:
        arcpy.ResetEnvironments()
        if logChn:
            logChn.closeLog()

